-- dithering matrix 3x3
function dithering(data)
	local width, height = data:getDimensions()
	local canvasImageData = love.image.newImageData(width, height)

	local matrix = {
-- 9 colors
		{ 28,   85,  28,  85 },
		{ 142, 198, 142, 198 },
		{ 113,  57, 113,  57 },
		{ 227, 170, 227, 170 },
	}

	local mh = #matrix
	local mw = #matrix[1]

	for y = 0, height - 1 do
		for x = 0, width - 1 do
			local r, g, b, a = love.math.colorToBytes(data:getPixel(x, y))
			local i, j = x%mw+1, y%mh+1
			local matrixValue = matrix[j][i]
			r = r >= matrixValue and 1 or 0
			g = g >= matrixValue and 1 or 0
			b = b >= matrixValue and 1 or 0
			canvasImageData:setPixel(x, y, r, g, b, a)
		end
	end
	local canvas = love.graphics.newImage(canvasImageData)
	return canvas
end

return dithering